using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace work_VCnet
{
	/// <summary>
	/// Summary description for calculator.
	/// </summary>
	public class calculator : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button Btndetail;
		internal System.Windows.Forms.ListBox ListBox1;
		internal System.Windows.Forms.TextBox CalcField;
		internal System.Windows.Forms.Button CalcRes;
		internal System.Windows.Forms.Button CalcPlus;
		internal System.Windows.Forms.Button CalcDec;
		internal System.Windows.Forms.Button CalcSign;
		internal System.Windows.Forms.Button Calc0;
		internal System.Windows.Forms.Button CalcCan;
		internal System.Windows.Forms.Button CalcSub;
		internal System.Windows.Forms.Button Calc3;
		internal System.Windows.Forms.Button Calc2;
		internal System.Windows.Forms.Button Calc1;
		internal System.Windows.Forms.Button CalcCE;
		internal System.Windows.Forms.Button CalcMul;
		internal System.Windows.Forms.Button Calc6;
		internal System.Windows.Forms.Button Calc5;
		internal System.Windows.Forms.Button Calc4;
		internal System.Windows.Forms.Button CalcBS;
		internal System.Windows.Forms.Button CalcDiv;
		internal System.Windows.Forms.Button Calc9;
		internal System.Windows.Forms.Button Calc8;
		internal System.Windows.Forms.Button Calc7;
		private System.Windows.Forms.RichTextBox richTextData;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		//variables
		double mOp1, mOp2;          //Previously input operand.
		int mNumOps;				//Number of operands.
		Operation mLastInput;       //Indicate type of last keypress event.
		string mOpFlag;             //Indicate pending operation.
		string mOpPrev;             //Previous operation
		string mMinus;              //Minus operator "-"
		string mDecValue;
		bool mAllowBackSpace;       //Allow backspace
		bool FirstFlag;
		
   
		enum Operation
		{
			None = 0,
			Operand = 1,
			Operator = 2,
			CE = 3,
			Cancel = 4
		}

		public calculator()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			//Get decimal separator based upon machine local settings.
			mDecValue = System.Globalization.NumberFormatInfo.CurrentInfo.NumberDecimalSeparator;
			this.CalcDec.Text = mDecValue;

			mMinus = "-";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Btndetail = new System.Windows.Forms.Button();
			this.ListBox1 = new System.Windows.Forms.ListBox();
			this.CalcField = new System.Windows.Forms.TextBox();
			this.CalcRes = new System.Windows.Forms.Button();
			this.CalcPlus = new System.Windows.Forms.Button();
			this.CalcDec = new System.Windows.Forms.Button();
			this.CalcSign = new System.Windows.Forms.Button();
			this.Calc0 = new System.Windows.Forms.Button();
			this.CalcCan = new System.Windows.Forms.Button();
			this.CalcSub = new System.Windows.Forms.Button();
			this.Calc3 = new System.Windows.Forms.Button();
			this.Calc2 = new System.Windows.Forms.Button();
			this.Calc1 = new System.Windows.Forms.Button();
			this.CalcCE = new System.Windows.Forms.Button();
			this.CalcMul = new System.Windows.Forms.Button();
			this.Calc6 = new System.Windows.Forms.Button();
			this.Calc5 = new System.Windows.Forms.Button();
			this.Calc4 = new System.Windows.Forms.Button();
			this.CalcBS = new System.Windows.Forms.Button();
			this.CalcDiv = new System.Windows.Forms.Button();
			this.Calc9 = new System.Windows.Forms.Button();
			this.Calc8 = new System.Windows.Forms.Button();
			this.Calc7 = new System.Windows.Forms.Button();
			this.richTextData = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// Btndetail
			// 
			this.Btndetail.BackColor = System.Drawing.SystemColors.ActiveBorder;
			this.Btndetail.Location = new System.Drawing.Point(304, 24);
			this.Btndetail.Name = "Btndetail";
			this.Btndetail.Size = new System.Drawing.Size(50, 20);
			this.Btndetail.TabIndex = 199;
			this.Btndetail.Text = "detail";
			this.Btndetail.Click += new System.EventHandler(this.Btndetail_Click);
			// 
			// ListBox1
			// 
			this.ListBox1.Font = new System.Drawing.Font("Times New Roman", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.ListBox1.ItemHeight = 14;
			this.ListBox1.Location = new System.Drawing.Point(376, 16);
			this.ListBox1.Name = "ListBox1";
			this.ListBox1.Size = new System.Drawing.Size(176, 172);
			this.ListBox1.TabIndex = 198;
			// 
			// CalcField
			// 
			this.CalcField.AccessibleRole = System.Windows.Forms.AccessibleRole.StaticText;
			this.CalcField.BackColor = System.Drawing.SystemColors.Window;
			this.CalcField.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.CalcField.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.CalcField.Location = new System.Drawing.Point(16, 16);
			this.CalcField.Name = "CalcField";
			this.CalcField.ReadOnly = true;
			this.CalcField.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.CalcField.Size = new System.Drawing.Size(184, 20);
			this.CalcField.TabIndex = 197;
			this.CalcField.Text = "0";
			this.CalcField.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// CalcRes
			// 
			this.CalcRes.BackColor = System.Drawing.SystemColors.Control;
			this.CalcRes.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcRes.Location = new System.Drawing.Point(208, 152);
			this.CalcRes.Name = "CalcRes";
			this.CalcRes.Size = new System.Drawing.Size(40, 32);
			this.CalcRes.TabIndex = 196;
			this.CalcRes.Text = "=";
			this.CalcRes.Click += new System.EventHandler(this.CalcRes_Click);
			// 
			// CalcPlus
			// 
			this.CalcPlus.BackColor = System.Drawing.SystemColors.Control;
			this.CalcPlus.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcPlus.Location = new System.Drawing.Point(256, 104);
			this.CalcPlus.Name = "CalcPlus";
			this.CalcPlus.Size = new System.Drawing.Size(40, 32);
			this.CalcPlus.TabIndex = 195;
			this.CalcPlus.Text = "+";
			this.CalcPlus.Click += new System.EventHandler(this.CalcPlus_Click);
			// 
			// CalcDec
			// 
			this.CalcDec.BackColor = System.Drawing.SystemColors.Control;
			this.CalcDec.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcDec.Location = new System.Drawing.Point(160, 152);
			this.CalcDec.Name = "CalcDec";
			this.CalcDec.Size = new System.Drawing.Size(40, 32);
			this.CalcDec.TabIndex = 194;
			this.CalcDec.Text = ".";
			this.CalcDec.Click += new System.EventHandler(this.CalcDec_Click);
			// 
			// CalcSign
			// 
			this.CalcSign.BackColor = System.Drawing.SystemColors.Control;
			this.CalcSign.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcSign.Location = new System.Drawing.Point(112, 152);
			this.CalcSign.Name = "CalcSign";
			this.CalcSign.Size = new System.Drawing.Size(40, 32);
			this.CalcSign.TabIndex = 193;
			this.CalcSign.Text = "+/-";
			this.CalcSign.Click += new System.EventHandler(this.CalcSign_Click);
			// 
			// Calc0
			// 
			this.Calc0.BackColor = System.Drawing.SystemColors.Control;
			this.Calc0.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc0.Location = new System.Drawing.Point(64, 152);
			this.Calc0.Name = "Calc0";
			this.Calc0.Size = new System.Drawing.Size(40, 32);
			this.Calc0.TabIndex = 192;
			this.Calc0.Text = "0";
			this.Calc0.Click += new System.EventHandler(this.Calc0_Click);
			// 
			// CalcCan
			// 
			this.CalcCan.BackColor = System.Drawing.SystemColors.Control;
			this.CalcCan.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcCan.Location = new System.Drawing.Point(304, 56);
			this.CalcCan.Name = "CalcCan";
			this.CalcCan.Size = new System.Drawing.Size(50, 32);
			this.CalcCan.TabIndex = 191;
			this.CalcCan.Text = "C";
			this.CalcCan.Click += new System.EventHandler(this.CalcCan_Click);
			// 
			// CalcSub
			// 
			this.CalcSub.BackColor = System.Drawing.SystemColors.Control;
			this.CalcSub.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcSub.Location = new System.Drawing.Point(208, 104);
			this.CalcSub.Name = "CalcSub";
			this.CalcSub.Size = new System.Drawing.Size(40, 32);
			this.CalcSub.TabIndex = 190;
			this.CalcSub.Text = "-";
			this.CalcSub.Click += new System.EventHandler(this.CalcSub_Click);
			// 
			// Calc3
			// 
			this.Calc3.BackColor = System.Drawing.SystemColors.Control;
			this.Calc3.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc3.Location = new System.Drawing.Point(64, 104);
			this.Calc3.Name = "Calc3";
			this.Calc3.Size = new System.Drawing.Size(40, 32);
			this.Calc3.TabIndex = 189;
			this.Calc3.Text = "3";
			this.Calc3.Click += new System.EventHandler(this.Calc3_Click);
			// 
			// Calc2
			// 
			this.Calc2.BackColor = System.Drawing.SystemColors.Control;
			this.Calc2.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc2.Location = new System.Drawing.Point(16, 104);
			this.Calc2.Name = "Calc2";
			this.Calc2.Size = new System.Drawing.Size(40, 32);
			this.Calc2.TabIndex = 188;
			this.Calc2.Text = "2";
			this.Calc2.Click += new System.EventHandler(this.Calc2_Click);
			// 
			// Calc1
			// 
			this.Calc1.BackColor = System.Drawing.SystemColors.Control;
			this.Calc1.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc1.Location = new System.Drawing.Point(16, 152);
			this.Calc1.Name = "Calc1";
			this.Calc1.Size = new System.Drawing.Size(40, 32);
			this.Calc1.TabIndex = 187;
			this.Calc1.Text = "1";
			this.Calc1.Click += new System.EventHandler(this.Calc1_Click);
			// 
			// CalcCE
			// 
			this.CalcCE.BackColor = System.Drawing.SystemColors.Control;
			this.CalcCE.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcCE.Location = new System.Drawing.Point(304, 104);
			this.CalcCE.Name = "CalcCE";
			this.CalcCE.Size = new System.Drawing.Size(50, 32);
			this.CalcCE.TabIndex = 186;
			this.CalcCE.Text = "CE";
			this.CalcCE.Click += new System.EventHandler(this.CalcCE_Click);
			// 
			// CalcMul
			// 
			this.CalcMul.BackColor = System.Drawing.SystemColors.Control;
			this.CalcMul.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcMul.Location = new System.Drawing.Point(256, 56);
			this.CalcMul.Name = "CalcMul";
			this.CalcMul.Size = new System.Drawing.Size(40, 32);
			this.CalcMul.TabIndex = 185;
			this.CalcMul.Text = "*";
			this.CalcMul.Click += new System.EventHandler(this.CalcMul_Click);
			// 
			// Calc6
			// 
			this.Calc6.BackColor = System.Drawing.SystemColors.Control;
			this.Calc6.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc6.Location = new System.Drawing.Point(16, 56);
			this.Calc6.Name = "Calc6";
			this.Calc6.Size = new System.Drawing.Size(40, 32);
			this.Calc6.TabIndex = 184;
			this.Calc6.Text = "6";
			this.Calc6.Click += new System.EventHandler(this.Calc6_Click);
			// 
			// Calc5
			// 
			this.Calc5.BackColor = System.Drawing.SystemColors.Control;
			this.Calc5.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc5.Location = new System.Drawing.Point(160, 104);
			this.Calc5.Name = "Calc5";
			this.Calc5.Size = new System.Drawing.Size(40, 32);
			this.Calc5.TabIndex = 183;
			this.Calc5.Text = "5";
			this.Calc5.Click += new System.EventHandler(this.Calc5_Click);
			// 
			// Calc4
			// 
			this.Calc4.BackColor = System.Drawing.SystemColors.Control;
			this.Calc4.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc4.Location = new System.Drawing.Point(112, 104);
			this.Calc4.Name = "Calc4";
			this.Calc4.Size = new System.Drawing.Size(40, 32);
			this.Calc4.TabIndex = 182;
			this.Calc4.Text = "4";
			this.Calc4.Click += new System.EventHandler(this.Calc4_Click);
			// 
			// CalcBS
			// 
			this.CalcBS.BackColor = System.Drawing.SystemColors.Control;
			this.CalcBS.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcBS.Location = new System.Drawing.Point(256, 152);
			this.CalcBS.Name = "CalcBS";
			this.CalcBS.Size = new System.Drawing.Size(96, 32);
			this.CalcBS.TabIndex = 181;
			this.CalcBS.Text = "BackSpace";
			this.CalcBS.Click += new System.EventHandler(this.CalcBS_Click);
			// 
			// CalcDiv
			// 
			this.CalcDiv.BackColor = System.Drawing.SystemColors.Control;
			this.CalcDiv.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.CalcDiv.Location = new System.Drawing.Point(208, 56);
			this.CalcDiv.Name = "CalcDiv";
			this.CalcDiv.Size = new System.Drawing.Size(40, 32);
			this.CalcDiv.TabIndex = 180;
			this.CalcDiv.Text = "/";
			this.CalcDiv.Click += new System.EventHandler(this.CalcDiv_Click);
			// 
			// Calc9
			// 
			this.Calc9.BackColor = System.Drawing.SystemColors.Control;
			this.Calc9.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc9.Location = new System.Drawing.Point(160, 56);
			this.Calc9.Name = "Calc9";
			this.Calc9.Size = new System.Drawing.Size(40, 32);
			this.Calc9.TabIndex = 179;
			this.Calc9.Text = "9";
			this.Calc9.Click += new System.EventHandler(this.Calc9_Click);
			// 
			// Calc8
			// 
			this.Calc8.BackColor = System.Drawing.SystemColors.Control;
			this.Calc8.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc8.Location = new System.Drawing.Point(112, 56);
			this.Calc8.Name = "Calc8";
			this.Calc8.Size = new System.Drawing.Size(40, 32);
			this.Calc8.TabIndex = 178;
			this.Calc8.Text = "8";
			this.Calc8.Click += new System.EventHandler(this.Calc8_Click);
			// 
			// Calc7
			// 
			this.Calc7.BackColor = System.Drawing.SystemColors.Control;
			this.Calc7.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(178)));
			this.Calc7.Location = new System.Drawing.Point(64, 56);
			this.Calc7.Name = "Calc7";
			this.Calc7.Size = new System.Drawing.Size(40, 32);
			this.Calc7.TabIndex = 177;
			this.Calc7.Text = "7";
			this.Calc7.Click += new System.EventHandler(this.Calc7_Click);
			// 
			// richTextData
			// 
			this.richTextData.Location = new System.Drawing.Point(232, 8);
			this.richTextData.Name = "richTextData";
			this.richTextData.Size = new System.Drawing.Size(15, 20);
			this.richTextData.TabIndex = 200;
			this.richTextData.Text = "";
			this.richTextData.Visible = false;
			// 
			// calculator
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.Teal;
			this.ClientSize = new System.Drawing.Size(562, 201);
			this.Controls.Add(this.richTextData);
			this.Controls.Add(this.Btndetail);
			this.Controls.Add(this.ListBox1);
			this.Controls.Add(this.CalcField);
			this.Controls.Add(this.CalcRes);
			this.Controls.Add(this.CalcPlus);
			this.Controls.Add(this.CalcDec);
			this.Controls.Add(this.CalcSign);
			this.Controls.Add(this.Calc0);
			this.Controls.Add(this.CalcCan);
			this.Controls.Add(this.CalcSub);
			this.Controls.Add(this.Calc3);
			this.Controls.Add(this.Calc2);
			this.Controls.Add(this.Calc1);
			this.Controls.Add(this.CalcCE);
			this.Controls.Add(this.CalcMul);
			this.Controls.Add(this.Calc6);
			this.Controls.Add(this.Calc5);
			this.Controls.Add(this.Calc4);
			this.Controls.Add(this.CalcBS);
			this.Controls.Add(this.CalcDiv);
			this.Controls.Add(this.Calc9);
			this.Controls.Add(this.Calc8);
			this.Controls.Add(this.Calc7);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "calculator";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "calculator";
			this.Load += new System.EventHandler(this.calculator_Load);
			this.Activated += new System.EventHandler(this.calculator_Activated);
			this.ResumeLayout(false);

		}
		#endregion

		private void calculator_Load(object sender, System.EventArgs e)
		{
			this.Width = this.CalcCan.Left + this.CalcCan.Width + this.Calc6.Left * 3 / 2;
			this.Btndetail.Text = "detail";
			this.Btndetail.Left = this.CalcCan.Left;
			this.Btndetail.Top = this.CalcField.Top + this.CalcField.Height - this.Btndetail.Height;

			this.ListBox1.Top = this.CalcField.Top + (((this.CalcBS.Top + this.CalcBS.Height) - this.CalcField.Top) / 2) - (this.ListBox1.Height / 2);
			this.ListBox1.Left = this.CalcCan.Left + this.CalcCan.Width + (this.Calc6.Left * 5 / 4);

		}

		private void calculator_Activated(object sender, System.EventArgs e)
		{
			//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
			this.ListBox1.Items.Clear();
			FirstFlag = true;
			//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		}

		private void Calc0_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void CalcNum_Click(object sender, System.EventArgs e)
		{
			System.Windows.Forms.Button	SelButton;
			mAllowBackSpace = true; //now allow backspace 

			if (mLastInput != Operation.Operand)
				this.CalcField.Text = "0";
			
			SelButton = (Button) sender;
			FormatEditField(SelButton.Text);

			mLastInput = Operation.Operand;
		}

		//format the entry in the text box!
		private void FormatEditField(string NewChar)
		{
			string Value; 
			Value = this.CalcField.Text;

			//Determine if there are more than one .'s
			if (NewChar == mDecValue)
			{
				//If it's found.
				this.richTextData.Text = Value;
				if  (this.richTextData.Find(mDecValue) > -1)    //Don't do anything.
					return;
            
				Value = Value + mDecValue;
			}
			else
			{
				if (Value == "0")
					Value = NewChar;
				else
					Value = Value + NewChar;
			
			}

			this.CalcField.Text = Value;
		}	

		private void Calc1_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void Calc2_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void Calc3_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void Calc4_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void Calc5_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void Calc6_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void Calc7_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void Calc8_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void Calc9_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void CalcDec_Click(object sender, System.EventArgs e)
		{
			this.CalcNum_Click(sender, e);
		}

		private void CalcPlus_Click(object sender, System.EventArgs e)
		{
			this.CalcRes_Click(sender, e);
		}


		//Handles +, -, *, /, =
		private void CalcRes_Click(object sender, System.EventArgs e)
		{		
			System.Windows.Forms.Button	 ButtonPressed;
			
			string vstr;
			string  vline;
			int i;

			vline = "-";

			//Now do not allow backspace(CalcBS) actions after the result has been
			//calculated and displayed.
			mAllowBackSpace = false;

			if (mLastInput.Equals(Operation.Operand)) 
				mNumOps = mNumOps + 1;

			switch(mNumOps)
			{
				case 1:
					mOp1 = Double.Parse(CalcField.Text);
					break;
				case 2:
					mOp2 = Double.Parse(CalcField.Text);

				switch(mOpFlag)
				{
					case "+":
						mOp1 = mOp1 + mOp2;
						break;
					case "-":
						mOp1 = mOp1 - mOp2;
						break;
					case "*":
						mOp1 = mOp1 * mOp2;
						break;
					case "/":
						if (mOp2 == 0)
							MessageBox.Show("Can't divide by zero! ...", work_VCnet.mainform.mainform_cl.Title, MessageBoxButtons.OK, MessageBoxIcon.Information);
						else
							mOp1 = mOp1 / mOp2;
						break;

					case "=":
						mOp1 = mOp2;
						break;
				}
				
					//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
					if (mOpFlag == "=") 
					{
					}

					else
					{
						this.ListBox1.Items.Add(mOpFlag);
						if (mNumOps == 2)
							this.ListBox1.Items.Add("     " + mOp2.ToString());
							 
					}
					//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

					this.CalcField.Text = mOp1.ToString();
					mNumOps = 1;
					
					//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
					if (mOpFlag == "=")
					{
						vstr = "     " + ".......... new operation ..........";
						this.ListBox1.Items.Add(vstr);
						vstr = "     " + mOp1.ToString() ;
						this.ListBox1.Items.Add(vstr);

						this.ListBox1.SelectedIndex = ListBox1.Items.Count - 1;
					}
					else
					{
						vstr = mOp1.ToString();
						for (i = 0 ; i <= (vstr.Length * 2) - 4; i++)
						{
							vline = vline + "-";
						}
                   
						this.ListBox1.Items.Add("     " + vline);
						this.ListBox1.Items.Add("     " + mOp1.ToString());

						this.ListBox1.SelectedIndex = ListBox1.Items.Count - 1;
					}
					//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
					break;
			}

			mLastInput = Operation.Operator;
			mOpPrev = mOpFlag;
	
			ButtonPressed = (Button) sender;
			mOpFlag = ButtonPressed.Text;

			// '''''''''''''''''''''''''''''''''''''''''''''''''''''''''
			if (FirstFlag == true)
			{
				vstr = "     " + ".......... new operation ..........";
				this.ListBox1.Items.Add(vstr);
				if (mNumOps == 1)
				{
					vstr = "      " + mOp1;
					this.ListBox1.Items.Add(vstr);
				}
			}
			FirstFlag = false;
			//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		}


		private void CalcMul_Click(object sender, System.EventArgs e)
		{
			this.CalcRes_Click(sender, e);
		}
	
		private void CalcDiv_Click(object sender, System.EventArgs e)
		{
			this.CalcRes_Click(sender, e);
		}
		
		private void CalcSub_Click(object sender, System.EventArgs e)
		{
			this.CalcRes_Click(sender, e);
		}
		
		//+/- click event.
		private void CalcSign_Click(object sender, System.EventArgs e)
		{
			if (mLastInput != Operation.Operand) 
				this.CalcField.Text = "0";
			else
			{
				if (this.CalcField.Text.Substring(0, 1) == mMinus)
					this.CalcField.Text = this.CalcField.Text.Substring(1);
				else
				{
					if (this.CalcField.Text != "0") 
						this.CalcField.Text = mMinus + this.CalcField.Text;
				}
	
			}

			mLastInput = Operation.Operand;	
		}

		//Cancel click event.
		private void CalcCan_Click(object sender, System.EventArgs e)
		{
			Reset();
			//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
			this.ListBox1.Items.Clear();
			FirstFlag = true;
			//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		}

		// Helper to initialize the vals.
		private void Reset()
		{
			mOp1 = 0;
			mOp2 = 0;

			mNumOps = 0;
			mLastInput = Operation.None;

			mOpFlag = "";
			mOpPrev = "";

			this.CalcField.Text = "0";

			mAllowBackSpace = true;
		}

		//Cancel entry click event.
		private void CalcCE_Click(object sender, System.EventArgs e)
		{
			if (mLastInput.Equals(Operation.Operand)) 
				this.CalcField.Text = "0";
			else
			{
				if (mLastInput.Equals(Operation.Operator))
					mOpFlag = mOpPrev;
			}

			mLastInput = Operation.CE;

			//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
			this.ListBox1.Items.Clear();
			FirstFlag = true;
			//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		}

		private void CalcBS_Click(object sender, System.EventArgs e)
		{
			string Value;

			//Check if we can backspace before removing items from CalcField.text.
			if (mAllowBackSpace == true)
			{
				Value = this.CalcField.Text;

				if (Value.Length > 1)
					///Value = Mid(Value, 1, Value.Length - 1);
					Value = Value.Substring(0, (Value.Length - 1));
				else
					Value = "0";
	

				//if all we are left is the minus sign, reset.
				if (Value == "-") 
					Value = "0";
	

				this.CalcField.Text = Value;
			}
		}

		private void Btndetail_Click(object sender, System.EventArgs e)
		{
			if (this.Btndetail.Text == "detail")
			{
			  this.Width = this.CalcCan.Left + this.CalcCan.Width + (this.Calc6.Left * 5 / 2) + this.ListBox1.Width;

			  this.Btndetail.Text = "hide";
			}

			else if (this.Btndetail.Text == "hide")
			{
				this.Width = this.CalcCan.Left + this.CalcCan.Width + this.Calc6.Left * 3 / 2;

				this.Btndetail.Text = "detail";
			}
		}

		

		




}
}
